Index: board_enable.c
===================================================================
--- board_enable.c	(revision 1288)
+++ board_enable.c	(working copy)
@@ -24,10 +24,13 @@
  * Contains the board specific flash enables.
  */
 
+#include <unistd.h>
 #include <string.h>
 #include "flash.h"
 #include "programmer.h"
 
+int usleep(useconds_t usec);
+
 #if defined(__i386__) || defined(__x86_64__)
 /*
  * Helper functions for many Winbond Super I/Os of the W836xx range.
@@ -35,64 +38,64 @@
 /* Enter extended functions */
 void w836xx_ext_enter(uint16_t port)
 {
-	OUTB(0x87, port);
-	OUTB(0x87, port);
+        OUTB(0x87, port);
+        OUTB(0x87, port);
 }
 
 /* Leave extended functions */
 void w836xx_ext_leave(uint16_t port)
 {
-	OUTB(0xAA, port);
+        OUTB(0xAA, port);
 }
 
 /* Generic Super I/O helper functions */
 uint8_t sio_read(uint16_t port, uint8_t reg)
 {
-	OUTB(reg, port);
-	return INB(port + 1);
+        OUTB(reg, port);
+        return INB(port + 1);
 }
 
 void sio_write(uint16_t port, uint8_t reg, uint8_t data)
 {
-	OUTB(reg, port);
-	OUTB(data, port + 1);
+        OUTB(reg, port);
+        OUTB(data, port + 1);
 }
 
 void sio_mask(uint16_t port, uint8_t reg, uint8_t data, uint8_t mask)
 {
-	uint8_t tmp;
+        uint8_t tmp;
 
-	OUTB(reg, port);
-	tmp = INB(port + 1) & ~mask;
-	OUTB(tmp | (data & mask), port + 1);
+        OUTB(reg, port);
+        tmp = INB(port + 1) & ~mask;
+        OUTB(tmp | (data & mask), port + 1);
 }
 
 /* Not used yet. */
 #if 0
 static int enable_flash_decode_superio(void)
 {
-	int ret;
-	uint8_t tmp;
+        int ret;
+        uint8_t tmp;
 
-	switch (superio.vendor) {
-	case SUPERIO_VENDOR_NONE:
-		ret = -1;
-		break;
-	case SUPERIO_VENDOR_ITE:
-		enter_conf_mode_ite(superio.port);
-		/* Enable flash mapping. Works for most old ITE style Super I/O. */
-		tmp = sio_read(superio.port, 0x24);
-		tmp |= 0xfc;
-		sio_write(superio.port, 0x24, tmp);
-		exit_conf_mode_ite(superio.port);
-		ret = 0;
-		break;
-	default:
-		msg_pdbg("Unhandled Super I/O type!\n");
-		ret = -1;
-		break;
-	}
-	return ret;
+        switch (superio.vendor) {
+        case SUPERIO_VENDOR_NONE:
+                ret = -1;
+                break;
+        case SUPERIO_VENDOR_ITE:
+                enter_conf_mode_ite(superio.port);
+                /* Enable flash mapping. Works for most old ITE style Super I/O. */
+                tmp = sio_read(superio.port, 0x24);
+                tmp |= 0xfc;
+                sio_write(superio.port, 0x24, tmp);
+                exit_conf_mode_ite(superio.port);
+                ret = 0;
+                break;
+        default:
+                msg_pdbg("Unhandled Super I/O type!\n");
+                ret = -1;
+                break;
+        }
+        return ret;
 }
 #endif
 
@@ -101,30 +104,30 @@
  */
 static int fdc37b787_gpio50_raise(uint16_t port)
 {
-	uint8_t id, val;
+        uint8_t id, val;
 
-	OUTB(0x55, port);	/* enter conf mode */
-	id = sio_read(port, 0x20);
-	if (id != 0x44) {
-		msg_perr("\nERROR: FDC37B787: Wrong ID 0x%02X.\n", id);
-		OUTB(0xAA, port); /* leave conf mode */
-		return -1;
-	}
+        OUTB(0x55, port);       /* enter conf mode */
+        id = sio_read(port, 0x20);
+        if (id != 0x44) {
+                msg_perr("\nERROR: FDC37B787: Wrong ID 0x%02X.\n", id);
+                OUTB(0xAA, port); /* leave conf mode */
+                return -1;
+        }
 
-	sio_write(port, 0x07, 0x08);	/* Select Aux I/O subdevice */
+        sio_write(port, 0x07, 0x08);    /* Select Aux I/O subdevice */
 
-	val = sio_read(port, 0xC8);	/* GP50 */
-	if ((val & 0x1B) != 0x10)	/* output, no invert, GPIO */
-	{
-		msg_perr("\nERROR: GPIO50 mode 0x%02X unexpected.\n", val);
-		OUTB(0xAA, port);
-		return -1;
-	}
+        val = sio_read(port, 0xC8);     /* GP50 */
+        if ((val & 0x1B) != 0x10)       /* output, no invert, GPIO */
+        {
+                msg_perr("\nERROR: GPIO50 mode 0x%02X unexpected.\n", val);
+                OUTB(0xAA, port);
+                return -1;
+        }
 
-	sio_mask(port, 0xF9, 0x01, 0x01);
+        sio_mask(port, 0xF9, 0x01, 0x01);
 
-	OUTB(0xAA, port);		/* Leave conf mode */
-	return 0;
+        OUTB(0xAA, port);               /* Leave conf mode */
+        return 0;
 }
 
 /*
@@ -133,98 +136,98 @@
  */
 static int fdc37b787_gpio50_raise_3f0(void)
 {
-	return fdc37b787_gpio50_raise(0x3f0);
+        return fdc37b787_gpio50_raise(0x3f0);
 }
 
 struct winbond_mux {
-	uint8_t reg;		/* 0 if the corresponding pin is not muxed */
-	uint8_t data;		/* reg/data/mask may be directly ... */
-	uint8_t mask;		/* ... passed to sio_mask */
+        uint8_t reg;            /* 0 if the corresponding pin is not muxed */
+        uint8_t data;           /* reg/data/mask may be directly ... */
+        uint8_t mask;           /* ... passed to sio_mask */
 };
 
 struct winbond_port {
-	const struct winbond_mux *mux; /* NULL or pointer to mux info for the 8 bits */
-	uint8_t ldn;		/* LDN this GPIO register is located in */
-	uint8_t enable_bit;	/* bit in 0x30 of that LDN to enable 
-	                           the GPIO port */
-	uint8_t base;		/* base register in that LDN for the port */
+        const struct winbond_mux *mux; /* NULL or pointer to mux info for the 8 bits */
+        uint8_t ldn;            /* LDN this GPIO register is located in */
+        uint8_t enable_bit;     /* bit in 0x30 of that LDN to enable
+                                   the GPIO port */
+        uint8_t base;           /* base register in that LDN for the port */
 };
 
 struct winbond_chip {
-	uint8_t device_id;	/* reg 0x20 of the expected w83626x */
-	uint8_t gpio_port_count;
-	const struct winbond_port *port;
+        uint8_t device_id;      /* reg 0x20 of the expected w83626x */
+        uint8_t gpio_port_count;
+        const struct winbond_port *port;
 };
 
 
 #define UNIMPLEMENTED_PORT {NULL, 0, 0, 0}
 
 enum winbond_id {
-	WINBOND_W83627HF_ID = 0x52,
-	WINBOND_W83627EHF_ID = 0x88,
-	WINBOND_W83627THF_ID = 0x82,
+        WINBOND_W83627HF_ID = 0x52,
+        WINBOND_W83627EHF_ID = 0x88,
+        WINBOND_W83627THF_ID = 0x82,
 };
 
 static const struct winbond_mux w83627hf_port2_mux[8] = {
-	{0x2A, 0x01, 0x01},	/* or MIDI */
-	{0x2B, 0x80, 0x80},	/* or SPI */
-	{0x2B, 0x40, 0x40},	/* or SPI */
-	{0x2B, 0x20, 0x20},	/* or power LED */
-	{0x2B, 0x10, 0x10},	/* or watchdog */
-	{0x2B, 0x08, 0x08},	/* or infra red */
-	{0x2B, 0x04, 0x04},	/* or infra red */
-	{0x2B, 0x03, 0x03}	/* or IRQ1 input */
+        {0x2A, 0x01, 0x01},     /* or MIDI */
+        {0x2B, 0x80, 0x80},     /* or SPI */
+        {0x2B, 0x40, 0x40},     /* or SPI */
+        {0x2B, 0x20, 0x20},     /* or power LED */
+        {0x2B, 0x10, 0x10},     /* or watchdog */
+        {0x2B, 0x08, 0x08},     /* or infra red */
+        {0x2B, 0x04, 0x04},     /* or infra red */
+        {0x2B, 0x03, 0x03}      /* or IRQ1 input */
 };
 
 static const struct winbond_port w83627hf[3] = {
-	UNIMPLEMENTED_PORT,
-	{w83627hf_port2_mux, 0x08, 0, 0xF0},
-	UNIMPLEMENTED_PORT
+        UNIMPLEMENTED_PORT,
+        {w83627hf_port2_mux, 0x08, 0, 0xF0},
+        UNIMPLEMENTED_PORT
 };
 
 static const struct winbond_mux w83627ehf_port2_mux[8] = {
-	{0x29, 0x06, 0x02},	/* or MIDI */
-	{0x29, 0x06, 0x02},
-	{0x24, 0x02, 0x00},	/* or SPI ROM interface */
-	{0x24, 0x02, 0x00},
-	{0x2A, 0x01, 0x01},	/* or keyboard/mouse interface */
-	{0x2A, 0x01, 0x01},
-	{0x2A, 0x01, 0x01},
-	{0x2A, 0x01, 0x01}
+        {0x29, 0x06, 0x02},     /* or MIDI */
+        {0x29, 0x06, 0x02},
+        {0x24, 0x02, 0x00},     /* or SPI ROM interface */
+        {0x24, 0x02, 0x00},
+        {0x2A, 0x01, 0x01},     /* or keyboard/mouse interface */
+        {0x2A, 0x01, 0x01},
+        {0x2A, 0x01, 0x01},
+        {0x2A, 0x01, 0x01}
 };
 
 static const struct winbond_port w83627ehf[6] = {
-	UNIMPLEMENTED_PORT,
-	{w83627ehf_port2_mux, 0x09, 0, 0xE3},
-	UNIMPLEMENTED_PORT,
-	UNIMPLEMENTED_PORT,
-	UNIMPLEMENTED_PORT,
-	UNIMPLEMENTED_PORT
+        UNIMPLEMENTED_PORT,
+        {w83627ehf_port2_mux, 0x09, 0, 0xE3},
+        UNIMPLEMENTED_PORT,
+        UNIMPLEMENTED_PORT,
+        UNIMPLEMENTED_PORT,
+        UNIMPLEMENTED_PORT
 };
 
 static const struct winbond_mux w83627thf_port4_mux[8] = {
-	{0x2D, 0x01, 0x01},	/* or watchdog or VID level strap */
-	{0x2D, 0x02, 0x02},	/* or resume reset */
-	{0x2D, 0x04, 0x04},	/* or S3 input */
-	{0x2D, 0x08, 0x08},	/* or PSON# */
-	{0x2D, 0x10, 0x10},	/* or PWROK */
-	{0x2D, 0x20, 0x20},	/* or suspend LED */
-	{0x2D, 0x40, 0x40},	/* or panel switch input */
-	{0x2D, 0x80, 0x80}	/* or panel switch output */
+        {0x2D, 0x01, 0x01},     /* or watchdog or VID level strap */
+        {0x2D, 0x02, 0x02},     /* or resume reset */
+        {0x2D, 0x04, 0x04},     /* or S3 input */
+        {0x2D, 0x08, 0x08},     /* or PSON# */
+        {0x2D, 0x10, 0x10},     /* or PWROK */
+        {0x2D, 0x20, 0x20},     /* or suspend LED */
+        {0x2D, 0x40, 0x40},     /* or panel switch input */
+        {0x2D, 0x80, 0x80}      /* or panel switch output */
 };
 
 static const struct winbond_port w83627thf[5] = {
-	UNIMPLEMENTED_PORT,	/* GPIO1 */
-	UNIMPLEMENTED_PORT,	/* GPIO2 */
-	UNIMPLEMENTED_PORT,	/* GPIO3 */
-	{w83627thf_port4_mux, 0x09, 1, 0xF4},
-	UNIMPLEMENTED_PORT	/* GPIO5 */
+        UNIMPLEMENTED_PORT,     /* GPIO1 */
+        UNIMPLEMENTED_PORT,     /* GPIO2 */
+        UNIMPLEMENTED_PORT,     /* GPIO3 */
+        {w83627thf_port4_mux, 0x09, 1, 0xF4},
+        UNIMPLEMENTED_PORT      /* GPIO5 */
 };
 
 static const struct winbond_chip winbond_chips[] = {
-	{WINBOND_W83627HF_ID,  ARRAY_SIZE(w83627hf),  w83627hf },
-	{WINBOND_W83627EHF_ID, ARRAY_SIZE(w83627ehf), w83627ehf},
-	{WINBOND_W83627THF_ID, ARRAY_SIZE(w83627thf), w83627thf},
+        {WINBOND_W83627HF_ID,  ARRAY_SIZE(w83627hf),  w83627hf },
+        {WINBOND_W83627EHF_ID, ARRAY_SIZE(w83627ehf), w83627ehf},
+        {WINBOND_W83627THF_ID, ARRAY_SIZE(w83627thf), w83627thf},
 };
 
 /*
@@ -233,22 +236,22 @@
  */
 static const struct winbond_chip *winbond_superio_detect(uint16_t base)
 {
-	uint8_t chipid;
-	const struct winbond_chip *chip = NULL;
-	int i;
+        uint8_t chipid;
+        const struct winbond_chip *chip = NULL;
+        int i;
 
-	w836xx_ext_enter(base);
-	chipid = sio_read(base, 0x20);
+        w836xx_ext_enter(base);
+        chipid = sio_read(base, 0x20);
 
-	for (i = 0; i < ARRAY_SIZE(winbond_chips); i++) {
-		if (winbond_chips[i].device_id == chipid) {
-			chip = &winbond_chips[i];
-			break;
-		}
-	}
+        for (i = 0; i < ARRAY_SIZE(winbond_chips); i++) {
+                if (winbond_chips[i].device_id == chipid) {
+                        chip = &winbond_chips[i];
+                        break;
+                }
+        }
 
-	w836xx_ext_leave(base);
-	return chip;
+        w836xx_ext_leave(base);
+        return chip;
 }
 
 /*
@@ -259,55 +262,55 @@
 static int winbond_gpio_set(uint16_t base, enum winbond_id chipid,
                             int pin, int raise)
 {
-	const struct winbond_chip *chip = NULL;
-	const struct winbond_port *gpio;
-	int port = pin / 10;
-	int bit = pin % 10;
+        const struct winbond_chip *chip = NULL;
+        const struct winbond_port *gpio;
+        int port = pin / 10;
+        int bit = pin % 10;
 
-	chip = winbond_superio_detect(base);
-	if (!chip) {
-		msg_perr("\nERROR: No supported Winbond Super I/O found\n");
-		return -1;
-	}
-	if (chip->device_id != chipid) {
-		msg_perr("\nERROR: Found Winbond chip with ID 0x%x, "
-		         "expected %x\n", chip->device_id, chipid);
-		return -1;
-	}
-	if (bit >= 8 || port == 0 || port > chip->gpio_port_count) {
-		msg_perr("\nERROR: winbond_gpio_set: Invalid GPIO number %d\n",
-		         pin);
-		return -1;
-	}
+        chip = winbond_superio_detect(base);
+        if (!chip) {
+                msg_perr("\nERROR: No supported Winbond Super I/O found\n");
+                return -1;
+        }
+        if (chip->device_id != chipid) {
+                msg_perr("\nERROR: Found Winbond chip with ID 0x%x, "
+                         "expected %x\n", chip->device_id, chipid);
+                return -1;
+        }
+        if (bit >= 8 || port == 0 || port > chip->gpio_port_count) {
+                msg_perr("\nERROR: winbond_gpio_set: Invalid GPIO number %d\n",
+                         pin);
+                return -1;
+        }
 
-	gpio = &chip->port[port - 1];
+        gpio = &chip->port[port - 1];
 
-	if (gpio->ldn == 0) {
-		msg_perr("\nERROR: GPIO%d is not supported yet on this"
-		          " winbond chip\n", port);
-		return -1;
-	}
+        if (gpio->ldn == 0) {
+                msg_perr("\nERROR: GPIO%d is not supported yet on this"
+                          " winbond chip\n", port);
+                return -1;
+        }
 
-	w836xx_ext_enter(base);
+        w836xx_ext_enter(base);
 
-	/* Select logical device. */
-	sio_write(base, 0x07, gpio->ldn);
+        /* Select logical device. */
+        sio_write(base, 0x07, gpio->ldn);
 
-	/* Activate logical device. */
-	sio_mask(base, 0x30, 1 << gpio->enable_bit, 1 << gpio->enable_bit);
+        /* Activate logical device. */
+        sio_mask(base, 0x30, 1 << gpio->enable_bit, 1 << gpio->enable_bit);
 
-	/* Select GPIO function of that pin. */
-	if (gpio->mux && gpio->mux[bit].reg)
-		sio_mask(base, gpio->mux[bit].reg,
-		         gpio->mux[bit].data, gpio->mux[bit].mask);
+        /* Select GPIO function of that pin. */
+        if (gpio->mux && gpio->mux[bit].reg)
+                sio_mask(base, gpio->mux[bit].reg,
+                         gpio->mux[bit].data, gpio->mux[bit].mask);
 
-	sio_mask(base, gpio->base + 0, 0, 1 << bit);	/* Make pin output */
-	sio_mask(base, gpio->base + 2, 0, 1 << bit);	/* Clear inversion */
-	sio_mask(base, gpio->base + 1, raise << bit, 1 << bit);
+        sio_mask(base, gpio->base + 0, 0, 1 << bit);    /* Make pin output */
+        sio_mask(base, gpio->base + 2, 0, 1 << bit);    /* Clear inversion */
+        sio_mask(base, gpio->base + 1, raise << bit, 1 << bit);
 
-	w836xx_ext_leave(base);
+        w836xx_ext_leave(base);
 
-	return 0;
+        return 0;
 }
 
 /*
@@ -319,7 +322,7 @@
  */
 static int w83627hf_gpio24_raise_2e(void)
 {
-	return winbond_gpio_set(0x2e, WINBOND_W83627HF_ID, 24, 1);
+        return winbond_gpio_set(0x2e, WINBOND_W83627HF_ID, 24, 1);
 }
 
 /*
@@ -330,7 +333,7 @@
  */
 static int w83627hf_gpio25_raise_2e(void)
 {
-	return winbond_gpio_set(0x2e, WINBOND_W83627HF_ID, 25, 1);
+        return winbond_gpio_set(0x2e, WINBOND_W83627HF_ID, 25, 1);
 }
 
 /*
@@ -341,7 +344,7 @@
  */
 static int w83627ehf_gpio24_raise_2e(void)
 {
-	return winbond_gpio_set(0x2e, WINBOND_W83627EHF_ID, 24, 1);
+        return winbond_gpio_set(0x2e, WINBOND_W83627EHF_ID, 24, 1);
 }
 
 /*
@@ -352,7 +355,7 @@
  */
 static int w83627thf_gpio44_raise_2e(void)
 {
-	return winbond_gpio_set(0x2e, WINBOND_W83627THF_ID, 44, 1);
+        return winbond_gpio_set(0x2e, WINBOND_W83627THF_ID, 44, 1);
 }
 
 /*
@@ -363,7 +366,7 @@
  */
 static int w83627thf_gpio44_raise_4e(void)
 {
-	return winbond_gpio_set(0x4e, WINBOND_W83627THF_ID, 44, 1);
+        return winbond_gpio_set(0x4e, WINBOND_W83627THF_ID, 44, 1);
 }
 
 /*
@@ -372,12 +375,12 @@
  */
 static void w836xx_memw_enable(uint16_t port)
 {
-	w836xx_ext_enter(port);
-	if (!(sio_read(port, 0x24) & 0x02)) {	/* Flash ROM enabled? */
-		/* Enable MEMW# and set ROM size select to max. (4M). */
-		sio_mask(port, 0x24, 0x28, 0x28);
-	}
-	w836xx_ext_leave(port);
+        w836xx_ext_enter(port);
+        if (!(sio_read(port, 0x24) & 0x02)) {   /* Flash ROM enabled? */
+                /* Enable MEMW# and set ROM size select to max. (4M). */
+                sio_mask(port, 0x24, 0x28, 0x28);
+        }
+        w836xx_ext_leave(port);
 }
 
 /*
@@ -394,9 +397,9 @@
  */
 static int w836xx_memw_enable_2e(void)
 {
-	w836xx_memw_enable(0x2E);
+        w836xx_memw_enable(0x2E);
 
-	return 0;
+        return 0;
 }
 
 /*
@@ -405,9 +408,9 @@
  */
 static int w836xx_memw_enable_4e(void)
 {
-	w836xx_memw_enable(0x4E);
+        w836xx_memw_enable(0x4E);
 
-	return 0;
+        return 0;
 }
 
 /*
@@ -416,89 +419,89 @@
  */
 int it8705f_write_enable(uint8_t port)
 {
-	uint8_t tmp;
-	int ret = 0;
+        uint8_t tmp;
+        int ret = 0;
 
-	enter_conf_mode_ite(port);
-	tmp = sio_read(port, 0x24);
-	/* Check if at least one flash segment is enabled. */
-	if (tmp & 0xf0) {
-		/* The IT8705F will respond to LPC cycles and translate them. */
-		buses_supported = CHIP_BUSTYPE_PARALLEL;
-		/* Flash ROM I/F Writes Enable */
-		tmp |= 0x04;
-		msg_pdbg("Enabling IT8705F flash ROM interface write.\n");
-		if (tmp & 0x02) {
-			/* The data sheet contradicts itself about max size. */
-			max_rom_decode.parallel = 1024 * 1024;
-			msg_pinfo("IT8705F with very unusual settings. Please "
-				  "send the output of \"flashrom -V\" to \n"
-				  "flashrom@flashrom.org with "
-				  "IT8705: your board name: flashrom -V\n"
-				  "as the subject to help us finish "
-				  "support for your Super I/O. Thanks.\n");
-			ret = 1;
-		} else if (tmp & 0x08) {
-			max_rom_decode.parallel = 512 * 1024;
-		} else {
-			max_rom_decode.parallel = 256 * 1024;
-		}
-		/* Safety checks. The data sheet is unclear here: Segments 1+3
-		 * overlap, no segment seems to cover top - 1MB to top - 512kB.
-		 * We assume that certain combinations make no sense.
-		 */
-		if (((tmp & 0x02) && !(tmp & 0x08)) || /* 1 MB en, 512 kB dis */
-		    (!(tmp & 0x10)) || /* 128 kB dis */
-		    (!(tmp & 0x40))) { /*  256/512 kB dis */
-			msg_perr("Inconsistent IT8705F decode size!\n");
-			ret = 1;
-		}
-		if (sio_read(port, 0x25) != 0) {
-			msg_perr("IT8705F flash data pins disabled!\n");
-			ret = 1;
-		}
-		if (sio_read(port, 0x26) != 0) {
-			msg_perr("IT8705F flash address pins 0-7 disabled!\n");
-			ret = 1;
-		}
-		if (sio_read(port, 0x27) != 0) {
-			msg_perr("IT8705F flash address pins 8-15 disabled!\n");
-			ret = 1;
-		}
-		if ((sio_read(port, 0x29) & 0x10) != 0) {
-			msg_perr("IT8705F flash write enable pin disabled!\n");
-			ret = 1;
-		}
-		if ((sio_read(port, 0x29) & 0x08) != 0) {
-			msg_perr("IT8705F flash chip select pin disabled!\n");
-			ret = 1;
-		}
-		if ((sio_read(port, 0x29) & 0x04) != 0) {
-			msg_perr("IT8705F flash read strobe pin disabled!\n");
-			ret = 1;
-		}
-		if ((sio_read(port, 0x29) & 0x03) != 0) {
-			msg_perr("IT8705F flash address pins 16-17 disabled!\n");
-			/* Not really an error if you use flash chips smaller
-			 * than 256 kByte, but such a configuration is unlikely.
-			 */
-			ret = 1;
-		}
-		msg_pdbg("Maximum IT8705F parallel flash decode size is %u.\n",
-			max_rom_decode.parallel);
-		if (ret) {
-			msg_pinfo("Not enabling IT8705F flash write.\n");
-		} else {
-			sio_write(port, 0x24, tmp);
-		}
-	} else {
-		msg_pdbg("No IT8705F flash segment enabled.\n");
-		/* Not sure if this is an error or not. */
-		ret = 0;
-	}
-	exit_conf_mode_ite(port);
+        enter_conf_mode_ite(port);
+        tmp = sio_read(port, 0x24);
+        /* Check if at least one flash segment is enabled. */
+        if (tmp & 0xf0) {
+                /* The IT8705F will respond to LPC cycles and translate them. */
+                buses_supported = CHIP_BUSTYPE_PARALLEL;
+                /* Flash ROM I/F Writes Enable */
+                tmp |= 0x04;
+                msg_pdbg("Enabling IT8705F flash ROM interface write.\n");
+                if (tmp & 0x02) {
+                        /* The data sheet contradicts itself about max size. */
+                        max_rom_decode.parallel = 1024 * 1024;
+                        msg_pinfo("IT8705F with very unusual settings. Please "
+                                  "send the output of \"flashrom -V\" to \n"
+                                  "flashrom@flashrom.org with "
+                                  "IT8705: your board name: flashrom -V\n"
+                                  "as the subject to help us finish "
+                                  "support for your Super I/O. Thanks.\n");
+                        ret = 1;
+                } else if (tmp & 0x08) {
+                        max_rom_decode.parallel = 512 * 1024;
+                } else {
+                        max_rom_decode.parallel = 256 * 1024;
+                }
+                /* Safety checks. The data sheet is unclear here: Segments 1+3
+                 * overlap, no segment seems to cover top - 1MB to top - 512kB.
+                 * We assume that certain combinations make no sense.
+                 */
+                if (((tmp & 0x02) && !(tmp & 0x08)) || /* 1 MB en, 512 kB dis */
+                    (!(tmp & 0x10)) || /* 128 kB dis */
+                    (!(tmp & 0x40))) { /*  256/512 kB dis */
+                        msg_perr("Inconsistent IT8705F decode size!\n");
+                        ret = 1;
+                }
+                if (sio_read(port, 0x25) != 0) {
+                        msg_perr("IT8705F flash data pins disabled!\n");
+                        ret = 1;
+                }
+                if (sio_read(port, 0x26) != 0) {
+                        msg_perr("IT8705F flash address pins 0-7 disabled!\n");
+                        ret = 1;
+                }
+                if (sio_read(port, 0x27) != 0) {
+                        msg_perr("IT8705F flash address pins 8-15 disabled!\n");
+                        ret = 1;
+                }
+                if ((sio_read(port, 0x29) & 0x10) != 0) {
+                        msg_perr("IT8705F flash write enable pin disabled!\n");
+                        ret = 1;
+                }
+                if ((sio_read(port, 0x29) & 0x08) != 0) {
+                        msg_perr("IT8705F flash chip select pin disabled!\n");
+                        ret = 1;
+                }
+                if ((sio_read(port, 0x29) & 0x04) != 0) {
+                        msg_perr("IT8705F flash read strobe pin disabled!\n");
+                        ret = 1;
+                }
+                if ((sio_read(port, 0x29) & 0x03) != 0) {
+                        msg_perr("IT8705F flash address pins 16-17 disabled!\n");
+                        /* Not really an error if you use flash chips smaller
+                         * than 256 kByte, but such a configuration is unlikely.
+                         */
+                        ret = 1;
+                }
+                msg_pdbg("Maximum IT8705F parallel flash decode size is %u.\n",
+                        max_rom_decode.parallel);
+                if (ret) {
+                        msg_pinfo("Not enabling IT8705F flash write.\n");
+                } else {
+                        sio_write(port, 0x24, tmp);
+                }
+        } else {
+                msg_pdbg("No IT8705F flash segment enabled.\n");
+                /* Not sure if this is an error or not. */
+                ret = 0;
+        }
+        exit_conf_mode_ite(port);
 
-	return ret;
+        return ret;
 }
 
 /*
@@ -510,28 +513,28 @@
  */
 static int it8707f_write_enable(uint8_t port)
 {
-	uint8_t tmp;
+        uint8_t tmp;
 
-	w836xx_ext_enter(port);
+        w836xx_ext_enter(port);
 
-	/* Set bit 3 (GLB_REG_WE) of reg 0x23: Makes reg 0x24-0x2A rw */
-	tmp = sio_read(port, 0x23);
-	tmp |= (1 << 3);
-	sio_write(port, 0x23, tmp);
+        /* Set bit 3 (GLB_REG_WE) of reg 0x23: Makes reg 0x24-0x2A rw */
+        tmp = sio_read(port, 0x23);
+        tmp |= (1 << 3);
+        sio_write(port, 0x23, tmp);
 
-	/* Set bit 2 (FLASH_WE) and bit 3 (FLASH_IF_EN) of reg 0x24 */
-	tmp = sio_read(port, 0x24);
-	tmp |= (1 << 2) | (1 << 3);
-	sio_write(port, 0x24, tmp);
+        /* Set bit 2 (FLASH_WE) and bit 3 (FLASH_IF_EN) of reg 0x24 */
+        tmp = sio_read(port, 0x24);
+        tmp |= (1 << 2) | (1 << 3);
+        sio_write(port, 0x24, tmp);
 
-	/* Clear bit 3 (GLB_REG_WE) of reg 0x23: Makes reg 0x24-0x2A ro */
-	tmp = sio_read(port, 0x23);
-	tmp &= ~(1 << 3);
-	sio_write(port, 0x23, tmp);
+        /* Clear bit 3 (GLB_REG_WE) of reg 0x23: Makes reg 0x24-0x2A ro */
+        tmp = sio_read(port, 0x23);
+        tmp &= ~(1 << 3);
+        sio_write(port, 0x23, tmp);
 
-	exit_conf_mode_ite(port);
+        exit_conf_mode_ite(port);
 
-	return 0;
+        return 0;
 }
 
 /*
@@ -540,7 +543,7 @@
  */
 static int it8707f_write_enable_2e(void)
 {
-	return it8707f_write_enable(0x2e);
+        return it8707f_write_enable(0x2e);
 }
 
 #define PC87360_ID 0xE1
@@ -548,42 +551,42 @@
 
 static int pc8736x_gpio_set(uint8_t chipid, uint8_t gpio, int raise)
 {
-	static const int bankbase[] = {0, 4, 8, 10, 12};
-	int gpio_bank = gpio / 8;
-	int gpio_pin = gpio % 8;
-	uint16_t baseport;
-	uint8_t id, val;
+        static const int bankbase[] = {0, 4, 8, 10, 12};
+        int gpio_bank = gpio / 8;
+        int gpio_pin = gpio % 8;
+        uint16_t baseport;
+        uint8_t id, val;
 
-	if (gpio_bank > 4) {
-		msg_perr("PC8736x: Invalid GPIO %d\n", gpio);
-		return -1;
-	}
+        if (gpio_bank > 4) {
+                msg_perr("PC8736x: Invalid GPIO %d\n", gpio);
+                return -1;
+        }
 
-	id = sio_read(0x2E, 0x20);
-	if (id != chipid) {
-		msg_perr("PC8736x: unexpected ID %02x (expected %02x)\n", id, chipid);
-		return -1;
-	}
+        id = sio_read(0x2E, 0x20);
+        if (id != chipid) {
+                msg_perr("PC8736x: unexpected ID %02x (expected %02x)\n", id, chipid);
+                return -1;
+        }
 
-	sio_write(0x2E, 0x07, 0x07);		/* Select GPIO device. */
-	baseport = (sio_read(0x2E, 0x60) << 8) | sio_read(0x2E, 0x61);
-	if ((baseport & 0xFFF0) == 0xFFF0 || baseport == 0) {
-		msg_perr("PC87360: invalid GPIO base address %04x\n",
-			 baseport);
-		return -1;
-	}
-	sio_mask (0x2E, 0x30, 0x01, 0x01);	/* Enable logical device. */
-	sio_write(0x2E, 0xF0, gpio_bank * 16 + gpio_pin);
-	sio_mask (0x2E, 0xF1, 0x01, 0x01);	/* Make pin output. */
+        sio_write(0x2E, 0x07, 0x07);            /* Select GPIO device. */
+        baseport = (sio_read(0x2E, 0x60) << 8) | sio_read(0x2E, 0x61);
+        if ((baseport & 0xFFF0) == 0xFFF0 || baseport == 0) {
+                msg_perr("PC87360: invalid GPIO base address %04x\n",
+                         baseport);
+                return -1;
+        }
+        sio_mask (0x2E, 0x30, 0x01, 0x01);      /* Enable logical device. */
+        sio_write(0x2E, 0xF0, gpio_bank * 16 + gpio_pin);
+        sio_mask (0x2E, 0xF1, 0x01, 0x01);      /* Make pin output. */
 
-	val = INB(baseport + bankbase[gpio_bank]);
-	if (raise)
-		val |= 1 << gpio_pin;
-	else
-		val &= ~(1 << gpio_pin);
-	OUTB(val, baseport + bankbase[gpio_bank]);
+        val = INB(baseport + bankbase[gpio_bank]);
+        if (raise)
+                val |= 1 << gpio_pin;
+        else
+                val &= ~(1 << gpio_pin);
+        OUTB(val, baseport + bankbase[gpio_bank]);
 
-	return 0;
+        return 0;
 }
 
 /*
@@ -591,55 +594,55 @@
  */
 static int via_vt823x_gpio_set(uint8_t gpio, int raise)
 {
-	struct pci_dev *dev;
-	uint16_t base;
-	uint8_t val, bit, offset;
+        struct pci_dev *dev;
+        uint16_t base;
+        uint8_t val, bit, offset;
 
-	dev = pci_dev_find_vendorclass(0x1106, 0x0601);
-	switch (dev->device_id) {
-	case 0x3177:	/* VT8235 */
-	case 0x3227:	/* VT8237R */
-	case 0x3337:	/* VT8237A */
-		break;
-	default:
-		msg_perr("\nERROR: VT823x ISA bridge not found.\n");
-		return -1;
-	}
+        dev = pci_dev_find_vendorclass(0x1106, 0x0601);
+        switch (dev->device_id) {
+        case 0x3177:    /* VT8235 */
+        case 0x3227:    /* VT8237R */
+        case 0x3337:    /* VT8237A */
+                break;
+        default:
+                msg_perr("\nERROR: VT823x ISA bridge not found.\n");
+                return -1;
+        }
 
-	if ((gpio >= 12) && (gpio <= 15)) {
-		/* GPIO12-15 -> output */
-		val = pci_read_byte(dev, 0xE4);
-		val |= 0x10;
-		pci_write_byte(dev, 0xE4, val);
-	} else if (gpio == 9) {
-		/* GPIO9 -> Output */
-		val = pci_read_byte(dev, 0xE4);
-		val |= 0x20;
-		pci_write_byte(dev, 0xE4, val);
-	} else if (gpio == 5) {
-		val = pci_read_byte(dev, 0xE4);
-		val |= 0x01;
-		pci_write_byte(dev, 0xE4, val);
-	} else {
-		msg_perr("\nERROR: "
-			"VT823x GPIO%02d is not implemented.\n", gpio);
-		return -1;
-	}
+        if ((gpio >= 12) && (gpio <= 15)) {
+                /* GPIO12-15 -> output */
+                val = pci_read_byte(dev, 0xE4);
+                val |= 0x10;
+                pci_write_byte(dev, 0xE4, val);
+        } else if (gpio == 9) {
+                /* GPIO9 -> Output */
+                val = pci_read_byte(dev, 0xE4);
+                val |= 0x20;
+                pci_write_byte(dev, 0xE4, val);
+        } else if (gpio == 5) {
+                val = pci_read_byte(dev, 0xE4);
+                val |= 0x01;
+                pci_write_byte(dev, 0xE4, val);
+        } else {
+                msg_perr("\nERROR: "
+                        "VT823x GPIO%02d is not implemented.\n", gpio);
+                return -1;
+        }
 
-	/* We need the I/O Base Address for this board's flash enable. */
-	base = pci_read_word(dev, 0x88) & 0xff80;
+        /* We need the I/O Base Address for this board's flash enable. */
+        base = pci_read_word(dev, 0x88) & 0xff80;
 
-	offset = 0x4C + gpio / 8;
-	bit = 0x01 << (gpio % 8);
+        offset = 0x4C + gpio / 8;
+        bit = 0x01 << (gpio % 8);
 
-	val = INB(base + offset);
-	if (raise)
-		val |= bit;
-	else
-		val &= ~bit;
-	OUTB(val, base + offset);
+        val = INB(base + offset);
+        if (raise)
+                val |= bit;
+        else
+                val &= ~bit;
+        OUTB(val, base + offset);
 
-	return 0;
+        return 0;
 }
 
 /*
@@ -648,8 +651,8 @@
  */
 static int via_vt823x_gpio5_raise(void)
 {
-	/* On M2V-MX: GPO5 is connected to WP# and TBL#. */
-	return via_vt823x_gpio_set(5, 1);
+        /* On M2V-MX: GPO5 is connected to WP# and TBL#. */
+        return via_vt823x_gpio_set(5, 1);
 }
 
 /*
@@ -658,7 +661,7 @@
  */
 static int via_vt823x_gpio9_raise(void)
 {
-	return via_vt823x_gpio_set(9, 1);
+        return via_vt823x_gpio_set(9, 1);
 }
 
 /*
@@ -670,7 +673,7 @@
  */
 static int via_vt823x_gpio15_raise(void)
 {
-	return via_vt823x_gpio_set(15, 1);
+        return via_vt823x_gpio_set(15, 1);
 }
 
 /*
@@ -682,12 +685,12 @@
  */
 static int board_msi_kt4v(void)
 {
-	int ret;
+        int ret;
 
-	ret = via_vt823x_gpio_set(12, 1);
-	w836xx_memw_enable(0x2E);
+        ret = via_vt823x_gpio_set(12, 1);
+        w836xx_memw_enable(0x2E);
 
-	return ret;
+        return ret;
 }
 
 /*
